/*
 * server.c
 *
 *  Created on: 2018. 5. 8.
 *      Author: minseo
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdbool.h>

#define BUFSIZE 1001

void main() {
    int server_fd;
    int client_fd;
    int server_len;
    int client_len;
    int receive_len;
    int data_size;
    int total_receive_len;
    struct sockaddr_in server_addr;
    struct sockaddr_in client_addr;
    char send_buf[BUFSIZE] = {'\0',};
    char receive_buf[BUFSIZE] = {'\0',};
    FILE *send_fp;
    int bValid = 1;

    // server 소켓 생성.
    if ((server_fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket failed");
        exit(1);
    }

    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = htonl(INADDR_ANY);  // 시스템마다 데이터를 저장하는 방식이 다르므로 동일한 형식으로 만들기 위해 네트워크 바이트 순서 방식으로 변경.
    server_addr.sin_port = htons(50000);

    setsockopt(server_fd, SOL_SOCKET, SO_REUSEADDR, (const char *)&bValid, sizeof(bValid));

    // server 소켓에 주소, 포트 정보 연결.
    if (bind(server_fd, (struct sockaddr*) &server_addr, sizeof(server_addr)) == -1) {
        perror("bind failed");
        exit(1);
    }

    // server로 들어오는 client를 기다림.
    // 5 : 클라이언트 요구가 대기하는 큐의 크기
    if (listen(server_fd, 5) == -1) {
        perror("listen failed");
        exit(1);
    }

    // server로 들어온 client가 있으면 요청을 받아들임.
    while (1) {
        client_len = sizeof(client_addr);

        if ((client_fd = accept(server_fd, (struct sockaddr*) &client_addr, &client_len)) == -1) {
            perror("accept failed");
            exit(1);
        }

        // 1. client로부터 data size를 전달 받음.
        if ((receive_len = recv(client_fd, receive_buf, BUFSIZE, 0)) == -1) {
            exit(1);
        }

//        printf("%s \n", receive_buf);

        data_size = atoi(receive_buf);

        printf("%d \n", data_size);

        // 2. client 받은 data size를 전달함.
        if (send(client_fd, receive_buf, strlen(receive_buf), 0) != strlen(receive_buf)) {
            exit(1);
        }

        // 요청을 받아들인 하나의 client에 대해서 반복.
        while(1) {
            memset(receive_buf, 0, BUFSIZE);

            //3. client로 부터 data를 전달 받음.
            if ((receive_len = recv(client_fd, receive_buf, BUFSIZE - 1, 0)) == -1) {
                perror("receive error");
                exit(1);
            }

            total_receive_len += receive_len;

            // 4. 더이상 client로부터 받는 data가 없으면 해당 client와 연결 종료.
            if(receive_len == 0) {
                printf("total_len: %d \n", total_receive_len);
                total_receive_len = 0;
                memset(receive_buf, 0, BUFSIZE);
                break;
            }

            printf("%d \n", receive_len);
            printf("Receive data: %s \n", receive_buf);
      }
        close(client_fd);
    }
}
